<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: DataStructure/BinarySearchTree/BinarySearchTreeNode.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_61f8caed08096df072032ac640f6feca.html">DataStructure</a></li><li class="navelem"><a class="el" href="dir_6ca12d504933556f9ebd2078a6fff522.html">BinarySearchTree</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">BinarySearchTreeNode.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="BinarySearchTreeNode_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef _BINARY_SEARCH_TREE_NODE_HPP</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define _BINARY_SEARCH_TREE_NODE_HPP</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Project includes</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NotImplementedException.h&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../../Exceptions/NullptrException.h&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceDataStructure.html">DataStructure</a></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;{</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html">   13</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode</a></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;{</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#ac76925aa4907ef142d80b8750fc5e110">   17</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#ac76925aa4907ef142d80b8750fc5e110">BinarySearchTreeNode</a>()</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    }</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#a08a46f3ddc835d5f79f52f1b35445c04">   24</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a08a46f3ddc835d5f79f52f1b35445c04">BinarySearchTreeNode</a>( TK newKey, TD newData )</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#afa3f97f1d7e056928a74ab95f6617774">key</a> = newKey;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a9676038d2b799e440950e47c69e7b782">data</a> = newData;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    }</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#a7e1f8d632231822cc00ac13f961c7f7d">   34</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7e1f8d632231822cc00ac13f961c7f7d">~BinarySearchTreeNode</a>()</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="comment">// destroy children</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">if</span> ( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a> != <span class="keyword">nullptr</span>  ) { <span class="keyword">delete</span> <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a>; }</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordflow">if</span> ( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a> != <span class="keyword">nullptr</span> ) { <span class="keyword">delete</span> <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>; }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    }</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">   42</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">   45</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">   48</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#a9676038d2b799e440950e47c69e7b782">   51</a></span>&#160;    TD <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a9676038d2b799e440950e47c69e7b782">data</a>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#afa3f97f1d7e056928a74ab95f6617774">   54</a></span>&#160;    TK <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#afa3f97f1d7e056928a74ab95f6617774">key</a>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTreeNode.html#a4f901b67b9d1a83f0c3be784eead987e">   57</a></span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classDataStructure_1_1BinarySearchTreeTester.html">BinarySearchTreeTester</a>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;};</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;} <span class="comment">// End namespace</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_aee9e5e5fce49d108070b08ca86263245"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">DataStructure::BinarySearchTreeNode::ptrRight</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * ptrRight</div><div class="ttdoc">Pointer to the right chlid of the node, which is greater in value.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:45</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a7a9931ebf665beb4334375980ea1c2bb"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">DataStructure::BinarySearchTreeNode::ptrLeft</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * ptrLeft</div><div class="ttdoc">Pointer to the left child of the node, which is lesser in value.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:42</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html">DataStructure::BinarySearchTreeNode</a></div><div class="ttdoc">A template node class, to be used in the BinarySearchTree class.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:13</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeTester_html"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeTester.html">DataStructure::BinarySearchTreeTester</a></div><div class="ttdoc">TESTER for the BinarySearchTree.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeTester.h:22</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_afa3f97f1d7e056928a74ab95f6617774"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#afa3f97f1d7e056928a74ab95f6617774">DataStructure::BinarySearchTreeNode::key</a></div><div class="ttdeci">TK key</div><div class="ttdoc">The key of this node.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:54</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a7e1f8d632231822cc00ac13f961c7f7d"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a7e1f8d632231822cc00ac13f961c7f7d">DataStructure::BinarySearchTreeNode::~BinarySearchTreeNode</a></div><div class="ttdeci">~BinarySearchTreeNode()</div><div class="ttdoc">Destroys left and right children, if they are not pointing to nullptr.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:34</div></div>
<div class="ttc" id="anamespaceDataStructure_html"><div class="ttname"><a href="namespaceDataStructure.html">DataStructure</a></div><div class="ttdef"><b>Definition:</b> BinarySearchTree.h:12</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a08a46f3ddc835d5f79f52f1b35445c04"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a08a46f3ddc835d5f79f52f1b35445c04">DataStructure::BinarySearchTreeNode::BinarySearchTreeNode</a></div><div class="ttdeci">BinarySearchTreeNode(TK newKey, TD newData)</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:24</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a305fb5a054cf1b1a840b8c79cbce955a"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">DataStructure::BinarySearchTreeNode::ptrParent</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * ptrParent</div><div class="ttdoc">Pointer to the parent node of this node.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:48</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a9676038d2b799e440950e47c69e7b782"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a9676038d2b799e440950e47c69e7b782">DataStructure::BinarySearchTreeNode::data</a></div><div class="ttdeci">TD data</div><div class="ttdoc">The data stored by the node.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:51</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_ac76925aa4907ef142d80b8750fc5e110"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#ac76925aa4907ef142d80b8750fc5e110">DataStructure::BinarySearchTreeNode::BinarySearchTreeNode</a></div><div class="ttdeci">BinarySearchTreeNode()</div><div class="ttdoc">Initializes left and right pointers to nullptr.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:17</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
